/*
Copyright (C) 2009 -  Claudio Salvadori 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef CREADER_H
#define CMESSAGE_H

#include <string.h>
#include <vector>
#include <iostream>

#include "IStreamReader.h"

/**
 *\file CReader.h
 *\date  Created on: 29-apr-2009
 *\author  Author: Claudio Salvadori
 *\brief Implemenation for IStreamReader interface to read, decode and divide packet to 
*	be passed to formatter. This class uses instantiation of the classes IStreamDaq, 
*	IDecoderDaq, IMessageDaq*/

/** 
*\class CReader
 *\brief Implemenation for IStreamReader interface to read, decode and divide packet to 
*	be passed to formatter. This class uses instantiation of the classes IStreamDaq, 
*	IDecoderDaq, IMessageDaq*/
class CReader: public IStreamReader{
	public:
		/**\brief CReader constructor */
		CReader();
		
		/**\brief CReader destructor */
		~CReader();
		
		/**\brief Initialize all the classes linked with reader with the stream definition
		*\return This method return one of the possible value from s_ret \see s_ret*/
		virtual s_ret getDefinition (struct SDef def);
				
		/**\brief This method divides the packet recived into message to be formatted (the lenght of each message is
		*		the pkt_lenght defined in the xml file)
		*\param buffer 	Pointer to a pointer of a vector of the messages to be formatted (output)
		*\return This method return one of the possible value from s_ret \see s_ret*/
		virtual s_ret retStream(std::vector<struct SMessage> *buffer);
		
	private:
		s_read_style		re_Style;	/**< Style of reading. */
		
		IStreamDaq* 		re_Source;	/**< Source from wich data is read */
		IDecoderDaq*		re_Decoder;	/**< Type of decoder choosen */
		IMessageDaq*		re_Message;	/**< Class to transform pkts in msgs */
};
#endif
