/*
Copyright (C) 2009 -  Claudio Salvadori 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _DATA_STRUCT_H_
#define _DATA_STRUCT_H_

#include <vector>
#include <string>
#include "DAQ_enum.h"

#ifdef ROOT_SYSTEM
#include "TObject.h"
#endif
/**
 *\file Data_struct.h
 *\date  Created on: 05-apr-2009
 *\author  Author: Claudio Salvadori
 *\brief Structure of formatted data: data formatted are stored inside
 *	SData vectors.
 */
 
/**
* \brief Structure of data elements
*/
#ifdef ROOT_SYSTEM
class SData: public TObject{
	public:
		std::string 	d_Name;		/**< Element name*/
		var_type	d_Type;		/**< Type of the element*/
		unsigned long	d_Size;		/**< Size of a d_Type vector (in numeber of d_type element)*/
		void*		d_Data; 	/**< Pointer to a data*/
		endianess_type	d_End;		/**< Endianess*/
};
#else
class SData{
	public:
		std::string 	d_Name;		/**< Element name*/
		var_type	d_Type;		/**< Type of the element*/
		unsigned long	d_Size;		/**< Size of a d_Type vector (in number of d_type element)*/
		void*		d_Data; 	/**< Pointer to a data*/
		endianess_type	d_End;		/**< Endianess*/
};
#endif

#endif
	
