/*
Copyright (C) 2009 -  Claudio Salvadori
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/**
 *\file CMessager.cpp
 *\brief  Divisor in messages functions development
 */
 
#include "CMessager.h"

using namespace std;

s_ret CMessager::getDefinition (struct SDef def){
	msg_Size = def.s_Size;
	
	//Is possible to insert inside the xml also the start and end character of a message
	//and to add functionalities inside this class to strip these
		
	return S_RET_OK;
}

s_ret CMessager::retStream(unsigned char *buffer_i, unsigned long length_i, std::vector<struct SMessage> *buffer_o){
	struct SMessage tmp_msg;
	
	if((length_i % msg_Size) != 0){
		//#ifdef DEBUG
		cerr << "Input length: " << length_i << " Message size: " << msg_Size << " Buffer: " << buffer_i << endl;
		//#endif 
		return S_M_LENGTH_ERR;
	}
	//Var init	
	buffer_o->clear();
	tmp_msg.me_Data = new unsigned char[msg_Size];
	
	for(unsigned long i = 0; i < (length_i / msg_Size); i++){
		tmp_msg.me_Size = msg_Size;
		
		//strcpy is not usable because buffer_i could have \0 in buffer 0 position... so i used for...
		for(unsigned long j = 0; j < msg_Size; j++){
			*(tmp_msg.me_Data + j) = (unsigned char)*(buffer_i + i * msg_Size + j);
			#ifdef DEBUG
			cerr << "Message n" << i << "element n" << j << ":" << hex << (int)*(buffer_i + i * msg_Size + j) 
					<< "(" << *(buffer_i + i * msg_Size + j) << ")" << endl;
			#endif
		}
		
		buffer_o->push_back(tmp_msg);
	}
	
	return S_RET_OK;

}
